/*

Media Circus v108
by Michael LeBlanc, NSCAD University 2011
http://leblanc.co.cc

HT1632 library by Gaurav Manek: 
https://github.com/gauravmm/HT1632-for-Arduino/tree/master/Arduino/HT1632

*/

#include <font_5x4.h>
#include <HT1632.h>
//#include "EtherShield.h"
#include <avr/pgmspace.h>

//EtherShield es = EtherShield();



prog_char head_0[] PROGMEM = ". . . New rules allow less justice for system on trial . . . ";
prog_char head_1[] PROGMEM = "Art can make you a millionaire overnight . . . ";
prog_char head_2[] PROGMEM = "Disappearing patients keeping up with demand . . . ";
prog_char head_3[] PROGMEM = "Former Liberal aide not asked to return evacuees home . . . ";
prog_char head_4[] PROGMEM = "Garlic-based bug repellent made of ‘swatting’ hoax . . . ";
prog_char head_5[] PROGMEM = "Fatal crash in a life without sunshine . . . ";
prog_char head_6[] PROGMEM = "Lawyer to become missing man in Saskatchewan lake . . . ";

PROGMEM const char *headline_table[] = 	   // change "string_table" name to suit
{   
  head_0,
  head_1,
  head_2,
  head_3,
  head_4,
  head_5,
  head_6 };

char buffer[75];    // make sure this is large enough for the largest string it must hold

int wd0, wd1, wd2, wd3, wd4, wd5, wd6; 
int i = 1;
int board;

void setup () {
  Serial.begin(9600);

  HT1632.begin(8, 7, 6, 5, 4, 3);
  
    // get widths
  
    strcpy_P(buffer, (char*)pgm_read_word(&(headline_table[0]))); // Necessary casts and dereferencing, just copy. 
    wd0 = HT1632.getTextWidth(buffer, FONT_5X4_WIDTH, FONT_5X4_HEIGHT);
    delay( 500 );
    strcpy_P(buffer, (char*)pgm_read_word(&(headline_table[1]))); // Necessary casts and dereferencing, just copy. 
    wd1 = HT1632.getTextWidth(buffer, FONT_5X4_WIDTH, FONT_5X4_HEIGHT);
    delay( 500 );
    strcpy_P(buffer, (char*)pgm_read_word(&(headline_table[2]))); // Necessary casts and dereferencing, just copy. 
    wd2 = HT1632.getTextWidth(buffer, FONT_5X4_WIDTH, FONT_5X4_HEIGHT);
    delay( 500 );
    strcpy_P(buffer, (char*)pgm_read_word(&(headline_table[3]))); // Necessary casts and dereferencing, just copy. 
    wd3 = HT1632.getTextWidth(buffer, FONT_5X4_WIDTH, FONT_5X4_HEIGHT);
    delay( 500 );
    strcpy_P(buffer, (char*)pgm_read_word(&(headline_table[4]))); // Necessary casts and dereferencing, just copy. 
    wd4 = HT1632.getTextWidth(buffer, FONT_5X4_WIDTH, FONT_5X4_HEIGHT);
    delay( 500 );
    strcpy_P(buffer, (char*)pgm_read_word(&(headline_table[5]))); // Necessary casts and dereferencing, just copy. 
    wd5 = HT1632.getTextWidth(buffer, FONT_5X4_WIDTH, FONT_5X4_HEIGHT);
    delay( 500 );
    strcpy_P(buffer, (char*)pgm_read_word(&(headline_table[6]))); // Necessary casts and dereferencing, just copy. 
    wd6 = HT1632.getTextWidth(buffer, FONT_5X4_WIDTH, FONT_5X4_HEIGHT);
    delay( 500 );
}

void loop () {
  
  board = 0;

  for (int whichBoard=4; whichBoard>=1; whichBoard--){
    board++;

    // Select board as the target of subsequent drawing/rendering operations.
    HT1632.drawTarget(BUFFER_BOARD(board));
    HT1632.clear();

    strcpy_P(buffer, (char*)pgm_read_word(&(headline_table[0])));
    HT1632.drawText(buffer, whichBoard*OUT_SIZE - i, 0,
    FONT_5X4, FONT_5X4_WIDTH, FONT_5X4_HEIGHT, FONT_5X4_STEP_GLYPH);
    
    strcpy_P(buffer, (char*)pgm_read_word(&(headline_table[1])));
    HT1632.drawText(buffer, whichBoard*OUT_SIZE - i + wd0, 0,
    FONT_5X4, FONT_5X4_WIDTH, FONT_5X4_HEIGHT, FONT_5X4_STEP_GLYPH);
    
    strcpy_P(buffer, (char*)pgm_read_word(&(headline_table[2])));
    HT1632.drawText(buffer, whichBoard*OUT_SIZE - i + wd0 + wd1, 0,
    FONT_5X4, FONT_5X4_WIDTH, FONT_5X4_HEIGHT, FONT_5X4_STEP_GLYPH);
    
    strcpy_P(buffer, (char*)pgm_read_word(&(headline_table[3])));
    HT1632.drawText(buffer, whichBoard*OUT_SIZE - i + wd0 + wd1 + wd2, 0,
    FONT_5X4, FONT_5X4_WIDTH, FONT_5X4_HEIGHT, FONT_5X4_STEP_GLYPH);
    
    strcpy_P(buffer, (char*)pgm_read_word(&(headline_table[4])));
    HT1632.drawText(buffer, whichBoard*OUT_SIZE - i + wd0 + wd1 + wd2 + wd3, 0,
    FONT_5X4, FONT_5X4_WIDTH, FONT_5X4_HEIGHT, FONT_5X4_STEP_GLYPH);
    
    strcpy_P(buffer, (char*)pgm_read_word(&(headline_table[5])));
    HT1632.drawText(buffer, whichBoard*OUT_SIZE - i + wd0 + wd1 + wd2 + wd3 + wd4, 0,
    FONT_5X4, FONT_5X4_WIDTH, FONT_5X4_HEIGHT, FONT_5X4_STEP_GLYPH);
    
    strcpy_P(buffer, (char*)pgm_read_word(&(headline_table[6])));
    HT1632.drawText(buffer, whichBoard*OUT_SIZE - i + wd0 + wd1 + wd2 + wd3 + wd4 + wd5, 0,
    FONT_5X4, FONT_5X4_WIDTH, FONT_5X4_HEIGHT, FONT_5X4_STEP_GLYPH); 


    HT1632.render(); // Board's contents updated.

  }

  i = (i+1)%(wd0 + wd1 + wd2 + wd3 + wd4 + wd5 + wd6 + OUT_SIZE * 3); // Make it repeating.

}
